= How do I set up Jenkins to build my project? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

[http://jenkins-ci.org Jenkins] is a continuous integration engine used to automate monitoring the 
source code repository, invoking automated builds which compile and test the application, 
perform code analysis, deploy the application, and other tasks.

Once a project is being maintained in source control (Subversion in the case of SecureCI™), Jenkins can
be configured to regularly monitor and build the project.

== For Maven projects ==
Visit the [//jenkins/ Jenkins dashboard] and select ''New Job'' from the left-hand side. Enter a ''Job name'' 
(e.g., `My Application`) and select ''Build a maven2 project'', then click '''OK'''.

There are many options you can set on this page to control how Jenkins builds and analyzes you project. Below 
are the options you can enable to get a typical Maven project building with a full complement of analysis.

||Project name||''populated from previous page''||
||Description||''optional''||
||Trac website||`https://`''XXX.XXX.XXX.XXX''`/trac/`||
||Source Code Management||Subversion||
||- Repository URL||`https://`''XXX.XXX.XXX.XXX''`/svn/myapp/trunk`||
||- Repository browser||Trac||
||Build periodically||`45 23 * * *` ''to build each night at 11:45PM''||
||Poll SCM||`*/5 * * * *` ''to check Subversion every 5 minutes''||
||Root POM||`pom.xml`||
||Goals and options||`checkstyle:checkstyle pmd:pmd pmd:cpd findbugs:findbugs cobertura:cobertura`||
||Publish Checkstyle analysis results||''checked''||
||Publish duplicate code analysis results||''checked''||
||Publish PMD analysis results||''checked''||
||Publish !FindBugs analysis results||''checked''||
||Scan for compiler warnings||''checked''||
||Publish Cobertura Coverage Report||''checked''||
||- Cobertura xml report pattern||`**/target/site/cobertura/coverage.xml`||
||Sonar||''checked''||
||- Sonar Triggers||Build periodically||

where ''XXX.XXX.XXX.XXX'' is the IP address or hostname of the SecureCI™ system. 

The ''Repository URL'' can be copied from the '''Subversion Location''' link under [//trac/browser/ Browse Source]. 
You'll usually want the URL for the '''trunk'''.

Click '''Save''' to save the project configuration. You may want to select ''Build Now'' from the left-hand
menu to test the configuration. To watch what is going on, view the build console by clicking on the build
under '''Build History''' and selecting ''Console Output'' from the left-hand menu.

== For Ant builds ==
Visit the [//jenkins/ Jenkins dashboard] and select ''New Job'' from the left-hand side. Enter a ''Job name'' 
(e.g., `My Application`) and select ''Build a free-style software project'', then click '''OK'''.

There are many options you can set on this page to control how Jenkins builds and analyzes you project. Below 
are the options you can enable to get a typical Ant project building with a full complement of analysis. 

(Note: The `build.xml` for the project must already be configured to run the tests, various code analysis tools,
and Cobertura. Jenkins will monitor the results, but doesn't run the tools itself.)

||Project name||''populated from previous page''||
||Description||''optional''||
||Trac website||`https://`''XXX.XXX.XXX.XXX''`/trac/`||
||Source Code Management||Subversion||
||- Repository URL||`https://`''XXX.XXX.XXX.XXX''`/svn/myapp/trunk`||
||- Repository browser||Trac||
||Build periodically||`45 23 * * *` ''to build each night at 11:45PM''||
||Poll SCM||`*/5 * * * *` ''to check Subversion every 5 minutes''||
||Add build step||Invoke Ant||
||- Ant version||ant-1.8.0||
||- Targets||`build test analyze coverage`||
||Publish JUnit test result report||''checked''||
||- Test report XMLs||`**/build/reports/junit/*.xml`||
||Scan for compiler warnings||''checked''||
||Publish Checkstyle analysis results||''checked''||
||Publish duplicate code analysis results||''checked''||
||Publish PMD analysis results||''checked''||
||Publish Cobertura Coverage Report||''checked''||
|| Cobertura xml report pattern||`**/build/reports/cobertura/coverage.xml`||
||Publish !FindBugs analysis results||''checked''||
||Sonar||''checked''||
||- Sonar Triggers||Build periodically||
||- Check if this project is NOT built with maven 2.||''checked''||
||-  Organisation id||`com.coveros`||
||-  Project id||`sample`||	
||-  Project name||`My Application`||
||-  Project description||`A sample application for Jenkins`||
||-  Project version||`1.0-SNAPSHOT`||	
||-  Source directories||`src`||
||-  Sources encoding||`UTF-8`||
||-  Compiled sources directory||`build/classes`||
||-  Java version||`<%= node['java']['jdk_full_version'] %>`||
||- Check to reuse reports generated by your build||''checked''||
||-  Surefire reports path||`build/reports/junit`||
||-  Cobertura report path||`build/reports/cobertura/coverage.xml`||
||-  Clover report path||''leave blank''||

where ''XXX.XXX.XXX.XXX'' is the IP address or hostname of the SecureCI™ system. 

The ''Repository URL'' can be copied from the '''Subversion Location''' link under [//trac/browser/ Browse Source]. 
You'll usually want the URL for the '''trunk'''.

Click '''Save''' to save the project configuration. You may want to select ''Build Now'' from the left-hand
menu to test the configuration. To watch what is going on, view the build console by clicking on the build
under '''Build History''' and selecting ''Console Output'' from the left-hand menu.

== Build Status and Weather Report ==

For each configured project, Jenkins displays a status (the blue or red ball) and a weather report (sunny to stormy)
on the dashboard. 

Status can be failed (red ball) or successful (blue ball). A successful build was a build that completed. The 
application was checked out from source control, was compiled successfully, and any tests and/or analyses were run. 
Tests may have failed, but Jenkins was able to complete what you configured the build to do.

Weather is an aggregate of the build status, test success, and possibly code coverage over the last 5 builds. A sunny
build has been building successfully, tests are passing, and code coverage is above a configured level. A stormy build
may have failed to build successfully, and/or may have tests failing or poor code coverage. Mouse-over the weather
icon to see a summary of how Jenkins determined the stability. 

Keep in mind that a build can be '''successful''' but '''unstable''' if it is compiling and tests are running, but 
the tests are failing.

=== More information ===

 * [http://wiki.jenkins-ci.org/display/JENKINS/Use+Jenkins Jenkins documentation]

<%= node['trac']['wiki']['footer'] %>